#!/bin/bash

mkdir -p ./units/
fpc -O4 -XX -CX -Cg ver.pas
./obtainmse.sh
fpc -O4 -XX -CX -Cg msepatch.pas
./msepatch
     if [ "$?" != "0" ]
     then
          echo 'MSE patch error - update FAILED :('
          exit
     fi
./ver
./compile_msetools.sh

command -v mold
MOLDEXISTS="$?"

fpc -Xs- -Ow -FWo.opt -OWAll -Cg -CfSSE64 -FU./units/ -Fu./  -Fu./mseide-msegui/lib/common/* -Fu./mseide-msegui/lib/common/kernel/linux -CX -XX -O2 -Mobjfpc gorg64.pas
if [ $MOLDEXISTS = "0" ] ; then
mold -run gcc -ffast-math -fforce-addr -funroll-loops -O4 -msse3 -fPIE -pie gorg64_spktone.c  -o gorg64_spktone -lm || fpc -Xs- -Ow -FWo.opt -OWAll -Cg -CfSSE64 -CX -XX -O4 -Mobjfpc gorg64_spktone.pas
else
gcc -ffast-math -fforce-addr -funroll-loops -O4 -msse3 -fPIE -pie gorg64_spktone.c  -o gorg64_spktone -lm || fpc -Xs- -Ow -FWo.opt -OWAll -Cg -CfSSE64 -CX -XX -O4 -Mobjfpc gorg64_spktone.pas
fi
fpc -Xs- -Ow -FWo.opt -OWAll -CfSSE64 -CX -XX -Cg -O4 dclockpanel.pas
#fasm gorg64_spkon.fasm && chmod =04755 gorg64_spkon
#fasm gorg64_spkoff.fasm && chmod =04755 gorg64_spkoff
#fasm gorg64_spkplay.fasm && chmod =04755 gorg64_spkplay

as gorg64_spkon.S -o gorg64_spkon.o 
if [ $MOLDEXISTS = "0" ] ; then
mold -L /usr/lib/x86_64-linux-gnu -lc --no-dynamic-linker --pie gorg64_spkon.o  -o gorg64_spkon
else
ld -lc --no-dynamic-linker --pie gorg64_spkon.o  -o gorg64_spkon
fi
rm gorg64_spkon.o || fpc -O4 -CX -XX gorg64_spkon.pas
as gorg64_spkoff.S -o gorg64_spkoff.o 
if [ $MOLDEXISTS = "0" ] ; then
mold -L /usr/lib/x86_64-linux-gnu -lc --no-dynamic-linker --pie gorg64_spkoff.o  -o gorg64_spkoff 
else
ld -lc --no-dynamic-linker --pie gorg64_spkoff.o  -o gorg64_spkoff 
fi
rm gorg64_spkoff.o || fpc -O4 -CX -XX gorg64_spkoff.pas
if [ $MOLDEXISTS = "0" ] ; then
mold -run gcc -ffast-math -fforce-addr -funroll-loops -O4 -msse3 -fPIE -pie gorg64_spkplay.c  -o gorg64_spkplay -lm || fpc -Xs- -Ow -FWo.opt -OWAll -Cg -CfSSE64 -CX -XX -O4 -Mobjfpc gorg64_spkplay.pas
else
gcc -ffast-math -fforce-addr -funroll-loops -O4 -msse3 -fPIE -pie gorg64_spkplay.c  -o gorg64_spkplay -lm || fpc -Xs- -Ow -FWo.opt -OWAll -Cg -CfSSE64 -CX -XX -O4 -Mobjfpc gorg64_spkplay.pas
fi
